// Sedgewick program 3.7
// Laufzeit dieses Programmes ist O(N**2) - warum?
// benutzt Point.java

// time java ClosePoints 100000 1.0 - 23sec
// time java ClosePoints 200000 1.0 - ?? Vervierfachung?

class ClosePoints { 
    // Listenelement
    static class Node {
	Point p;
	Node next;
        Node(Point x, Node t) {
		 p = x; next = t;
	} 
    }
    static int G, cnt = 0; 
    static double d;

    // zweidimensionales Feld
    // jeder Feldeintrag enthält Liste von Punkten
    static Node[][] g;

    
    static void gridInsert(Point p) {
	int X = (int)(p.x*G)+1;
	int Y = (int)(p.y*G)+1;
        Node s, t = new Node(p, g[X][Y]);

	// betrachte 8 benachbarte Grid-Einträge
        // ermittle Distanzen für alle dort in Listen gespeicherten Punkte
	// Betrachtung von 8 Nachbarn reicht aus wegen Skalierungsfaktor G
        for (int i = X-1; i <= X+1; i++)
          for (int j = Y-1; j <= Y+1; j++)
            for (s = g[i][j]; s != null; s = s.next)  	
              if (s.p.distance(t.p) < d)
		cnt++;  // global
        g[X][Y] = t;
    }

    // Generiere zufällig eine Menge von Punkten im Einheitsquadrat
    // Bestimmme Paare von Punkten, die weniger als d entfernt sind
    public static void main(String[] args) {
	int i, N = 0;
	try {
		N = Integer.parseInt(args[0]);
        	d = Double.parseDouble(args[1]);
	} catch (Exception e) {
		Out.println("Usage: java ClosePoints #points mindist");
		System.exit(1);
	}
	// Normalisierung: Rechnen im Einheitsquadrat 1x1
	// Initialisiere Skalierungsfaktor G
        G = (int) (1.0/d);
        g = new Node[G+2][G+2];
        for (i = 0; i < G+2; i++)
          for (int j = 0; j < G+2; j++)
            	g[i][j] = null;

	// Zufällig generierte Punkte ins 2-dim. Feld einfügen
        for (i = 0; i < N; i++)
          	gridInsert(new Point());

	// Auswertung
        Out.print(cnt + " pairs ");
        Out.println("closer than " + d);
    }
}
