// Sedgewick, program 3.8
// einfach verkettete Liste; Ringstruktur
//
// Josephus-Problem:
// N Personen stehen im Kreis
// Wählen Anführer durch Abzählen; entfernen jeden M-ten aus dem Kreis

class Josephus
  { 
    static class Node {
	int val;
	Node next;
        Node(int v) { val = v; }
	protected void finalize() throws Throwable {
		Out.println( "finalizer: Node " + val + " deleted" ); 
		super.finalize();
	}
    }

    public static void main(String[] args) {
	int N = 0, M = 0;

	try {
		N = Integer.parseInt(args[0]);
        	M = Integer.parseInt(args[1]);
	} catch (Exception e) {
		Out.println("Usage: Josephus #Nodes #Deleted");
		System.exit(1);
	}

	// Aufbau einer Ringstruktur mit N Elementen
        Node t = new Node(1);
        Node x = t;
        for (int i = 2; i <= N; i++)
          	x = (x.next = new Node(i));
        x.next = t;

	// Löschen jedes M-ten Elements aus dem Ring
        while (x != x.next) {
            for (int i = 1; i < M; i++) 
		 x = x.next;
	    Out.println("Node " + x.next.val + " to be deleted");
            x.next = x.next.next;
        }

	// Garbage Collection anstossen (nur ein Hinweis...)
	System.gc();

        Out.println("Survivor is " + x.val);
	
	// try {
    	//	Thread.sleep(1000);
 	//} catch(InterruptedException ex) {
     	//	Thread.currentThread().interrupt();
 	//}
      }
  }
